#include <stdio.h>
#include <stdlib.h>
#include <dtk.h>
#include <fstream.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

int running = 1;

void signal_catcher(int sig)
{
  dtkMsg.add(DTKMSG_INFO, "caught signal %d ... exiting\n",sig);
  // Setting run = 0 will cause the main loop to terminate when it
  running=0;
}

main(int argc, char **argv) {
  //  Shared memory segment used to request a system call
  dtkSharedMem* shm4;
  //  Shared memory segment to put the call
  dtkSharedMem* shm_call;

  unsigned char newCall;
  shm4 = new dtkSharedMem(sizeof(unsigned char), "runCommandFlag");
  if(!shm4 || shm4->isInvalid())
      shm4 = NULL ;
  else {
    newCall = 1 ;
    shm4->write(&newCall);
  }

  shm_call = new dtkSharedMem(sizeof(char)*1024, "runCommandString");
  if(!shm_call || shm_call->isInvalid())
      shm_call = NULL ;

  char *callName = new char[100];
  char *nameAlone = new char[100];

  signal(SIGINT,signal_catcher);
  signal(SIGQUIT,signal_catcher);
  signal(SIGTERM,signal_catcher);

  if (!shm4) running = 1;
  //pid_t pid = NULL;

  // if there is a killall arguement, set a switch
  //char *callIt = new char[100];
  //bool isThere = false;
  //if (argc > 1) {
  //  isThere = true;
  //  callIt = argv[1];
  //}
  while(running == 1 && shm4 != NULL) {

    if(!shm4 || shm4->isInvalid()) {
      shm4 = NULL;
      running = 0;
      dtkMsg.add(DTKMSG_ERROR, "shared memory flag unavailable. \n");
      break;
    }
    else {
      shm4->read(&newCall);
      while (running == 1 && newCall == 1) {
	// test to see if the memory is still there
	if (shm4 && shm4->isValid()) {
	  shm4->read(&newCall);
	}
	else {
	  running = 0;
	  break;
	}
	usleep(100);
      }
      if (newCall == 2 ) {
	if (shm_call && shm_call->isValid()) {
	  //printf("in dtk-runCommand: reading callname\n");
	  shm_call->read(callName);
	  // see if there is a valid command
	  if (callName != NULL) {
	    //printf("calling system in dtk-runCommand with: %s\n",callName);
	    system(callName);
	    //printf("back from system in dtk-runCommand\n");
	    // send a signal back when system call is finished
	    newCall = 1; 
	    if (shm4 && shm4->isValid()) {
	      shm4->write(&newCall);
	    }
	    //printf("reset newcallset in dtk-runCommand\n");
	  }
	}
      }
      if (newCall == 3) {
	running = 0;
      }
    }
  }

  //delete shm4;
  //delete shm_call;

  return 0;
}
