/* prints the size of shared memory segment
   
   John Kelso, 9/04, kelso@nist.gov

*/

#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include <dtk.h>

static int Usage(char *name) {
  fprintf(stderr,
	  " Usage: %s SHM_FILE\n\n"
	  "  Prints the size of a shared memory file named SHM_FILE\n",
	  name) ;
  return 1 ;
}

int main(int argc, char **argv) {
  
  dtkMsg.setPreMessage(argv[0]) ;
  
  if (argc != 2) 
    return Usage(argv[0]) ;
  
  char *name = argv[1] ;
  
  int size ;

  dtkSharedMem *shm = NULL ;
  shm = new dtkSharedMem(name) ;
  if(shm->isInvalid()) 
    return 1 ;
  size = shm->getSize() ;
  
  printf("%d\n",size) ;

  return 0 ;
}
