#include <string.h>
#include <strings.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string>

using namespace std ;

bool testForM4(char* nameStore) {
  char *suf ;
  bool suf_found = false;
  if (strlen(nameStore)>0) {
    suf = strrchr(nameStore, '.') ;
    if (suf) {
      if (strcasecmp(suf,".m4")==0)
	suf_found = true;
    }
  }
  return suf_found;
}

string getM4FilteredFile(char* c_filename,
  dtkSharedMem* shm4, dtkSharedMem* shm_call) {
  char* newName = new char[100];
  string filename = c_filename ;
    
  // base of m4 output file
  string base ;
    
  // is there a directory in filename?
  string::size_type dir = filename.rfind('/') ;
  if (dir == string::npos)
    base = filename ;
  else 
    base = filename.substr(dir+1) ;
  
  // get temp dir
  string tmpdir ;
  if (getenv("M4TMPDIR")) 
    tmpdir = getenv("M4TMPDIR") ;
  else
    tmpdir = "/var/tmp" ;
  DIR *dirp ;
  if (!(dirp=opendir(tmpdir.c_str()))) {
    return NULL ;
  }
  closedir(dirp) ;
  
  // extract ".m4"
  base = base.substr(0,base.rfind('.')) ;
  //cout << "base = " << base << endl ;
  
  // try to find a unused output file name
  string out ;

  // come up with a tempname
  char c_pid[11] ;
  sprintf(c_pid,"%10.10d",(int)getpid()) ;
  string pid = c_pid ;
    
  out = tmpdir + "/libpfm4-" + pid + "-" + "-" + base ;

  string cmd = "m4<" + filename + ">" + out ;

  // use dtk-runCommand to run it
  // set the flag to tell the other program to read a call
  unsigned char newCallSet = 2;
  if (shm4)
    shm4->write(&newCallSet);
  if (shm_call) {
    shm_call->write(cmd.c_str());
  }

  return out;
}
