#include <stdio.h>
#include <stdlib.h>
#include <dtk.h>
//#include <fstream.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ptrace.h>

void usage() {
  printf("usage: \nhev-clipwand (-x,+x,-y,+y,-z,+z) float (1-6 entries)\n");
}

int findPlane(char* xyz) {
  int planeNum = 0;
  char* xplus = new char[3];
  char* xminus = new char[3];
  char* yplus = new char[3];
  char* yminus = new char[3];
  char* zplus = new char[3];
  char* zminus = new char[3];
  xplus = "+x";;
  xminus = "-x";
  yplus = "+y";
  yminus = "-y";
  zplus = "+z";
  zminus = "-z";
  if (strcasecmp(xyz,xplus) == 0) planeNum = 1;
  if (strcasecmp(xyz,xminus) == 0) planeNum = 2;
  if (strcasecmp(xyz,yplus) == 0) planeNum = 3;
  if (strcasecmp(xyz,yminus) == 0) planeNum = 4;
  if (strcasecmp(xyz,zplus) == 0) planeNum = 5;
  if (strcasecmp(xyz,zminus) == 0) planeNum = 6;
  return planeNum;
}

main(int argc, char **argv) {
  // set up shared memory for clipWand (6 floats)
  dtkSharedMem* shmBox;
  dtkSharedMem* shmPlanesOn;

  shmBox = new dtkSharedMem( 6*sizeof(float), "dval6");
  shmPlanesOn = new dtkSharedMem (6*sizeof(unsigned char), "planeson");

  if(!shmBox || shmBox->isInvalid())
      shmBox = NULL ;

  if(!shmPlanesOn || shmPlanesOn->isInvalid())
      shmPlanesOn = NULL ;

  float box[6];
  int planesWanted = 0;
  int planeNum;
  unsigned char pon[6];
  for ( int i = 0; i < 6; ++i ) {
    pon[i] = 0;
    box[i] = 0.0;
  }
  
  // first parse the input
  if (argc < 3) {
    usage();
  }
  else if (argc == 3 || argc ==5 || argc == 7 || argc == 9 || argc == 11 || argc == 13) {
    planeNum = findPlane(argv[1]);
    box[planeNum-1] = atof(argv[2]);
    pon[planeNum-1] = 1;
    ++planesWanted;
    if (argc == 5 || argc == 7 || argc == 9 || argc == 11 || argc == 13) {
      planeNum = findPlane(argv[3]);
      box[planeNum-1] = atof(argv[4]);
      pon[planeNum-1] = 1;
      ++planesWanted;
      if (argc == 7 || argc == 9 || argc == 11 || argc == 13) {
	planeNum = findPlane(argv[5]);
	box[planeNum-1] = atof(argv[6]);
	pon[planeNum-1] = 1;
	++planesWanted;
	if (argc == 9 || argc == 11 || argc == 13) {
	  planeNum = findPlane(argv[7]);
	  box[planeNum-1] = atof(argv[8]);
	  pon[planeNum-1] = 1;
	  ++planesWanted;
	  if (argc == 11 || argc == 13) {
	    planeNum = findPlane(argv[9]);
	    box[planeNum-1] = atof(argv[10]);
	    pon[planeNum-1] = 1;
	    ++planesWanted;
	    if (argc == 13) {
	      planeNum = findPlane(argv[11]);
	      box[planeNum-1] = atof(argv[12]);
	      pon[planeNum-1] = 1;
	      ++planesWanted;
	    }
	  }
	}
      }
    }
  }
  else {
    usage();
  }

  // send to clipWand DSO
  if (shmBox && shmBox->isValid()) {
    shmBox->write(&box);
  }
  if (shmPlanesOn && shmPlanesOn->isValid()) {
    shmPlanesOn->write(&pon);
  }

  delete shmBox;
  delete shmPlanesOn;
  return 0;
}
