#include <stdio.h>
#include <stdlib.h>
#include <dtk.h>
//#include <fstream.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ptrace.h>

void usage() {
  printf("usage: \nhev-clipwand (on/off) (-x,+x,-y,+y,-z,+z) float (1-6 entries)\n");
}

int findPlane(char* xyz) {
  int planeNum = 0;
  char* xplus = new char[3];
  char* xminus = new char[3];
  char* yplus = new char[3];
  char* yminus = new char[3];
  char* zplus = new char[3];
  char* zminus = new char[3];
  xplus = "+x";;
  xminus = "-x";
  yplus = "+y";
  yminus = "-y";
  zplus = "+z";
  zminus = "-z";
  if (strcasecmp(xyz,xplus) == 0) planeNum = 1;
  if (strcasecmp(xyz,xminus) == 0) planeNum = 2;
  if (strcasecmp(xyz,yplus) == 0) planeNum = 3;
  if (strcasecmp(xyz,yminus) == 0) planeNum = 4;
  if (strcasecmp(xyz,zplus) == 0) planeNum = 5;
  if (strcasecmp(xyz,zminus) == 0) planeNum = 6;
  return planeNum;
}

main(int argc, char **argv) {
  // set up shared memory for clipWand (6 floats)
  dtkSharedMem* shmBox;
  dtkSharedMem* shmPlanesOn;
  dtkSharedMem* shm2;

  shmBox = new dtkSharedMem( 6*sizeof(float), "dval6");
  shmPlanesOn = new dtkSharedMem (6*sizeof(unsigned char), "planeson");
  shm2 = new dtkSharedMem(sizeof(unsigned char), "doclip");

  if(!shmBox || shmBox->isInvalid())
      shmBox = NULL ;

  if(!shmPlanesOn || shmPlanesOn->isInvalid())
      shmPlanesOn = NULL ;

  if(!shm2 || shm2->isInvalid()) {
      shm2 = NULL;
  }

  char* onchar = new char[3];
  onchar = "on";
  char* offchar = new char[4];
  offchar = "off";
  unsigned char selected;

  float box[6];
  int planesWanted = 0;
  int planeNum;
  unsigned char pon[6];
  for ( int i = 0; i < 6; ++i ) {
    pon[i] = 0;
    box[i] = 0.0;
  }
  int numParameters = 1;
  
  // first parse the input
  if (argc < 3) {
    usage();
  }
  else {
    // if there are on or off parameters, they should be first
    if (strcasecmp(onchar, argv[1]) == 0) {
      // turn on mode
      selected = 1;
      if (shm2)
	shm2->write(&selected);
      ++numParameters;
    }
    else if (strcasecmp(offchar, argv[1]) == 0) {
      // turn off mode
      selected = 0;
      if (shm2)
	shm2->write(&selected);
      ++numParameters;
    }
    
    // now deal with all the plane definitions
    for ( int j = numParameters; j < argc; ++j ) {
      planeNum = findPlane(argv[j]);
      if (planeNum == 0 || argc < (j+2)) {
	usage();
	break;
      }
      box[planeNum-1] = atof(argv[j+1]);
      pon[planeNum-1] = 1;
      ++planesWanted;
      ++j;
    }
  }

  // send to clipWand DSO
  if (shmBox && shmBox->isValid()) {
    shmBox->write(&box);
  }
  if (shmPlanesOn && shmPlanesOn->isValid()) {
    shmPlanesOn->write(&pon);
  }

  delete shmBox;
  delete shmPlanesOn;
  return 0;
}
