#include <stdio.h>
#include <stdlib.h>
#include <dtk.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ptrace.h>
#include <string>

using namespace std ;

void usage();
bool isCommandCorrect(char* command);

main(int argc, char **argv) {

  dtkSharedMem* shm_mode;
  dtkSharedMem* shm_seq;
  int numPlots = 2;

  // first check for a good command
  if (argc < 2)
    usage();

  char seqnode[100];

  // Check if there is a shared memory segment "histogram" 
  shm_mode = new dtkSharedMem(sizeof(int), "hydration-plot");
  if(!shm_mode || shm_mode->isInvalid()) 
    shm_mode = NULL ;

  // define shared memory for a filename to be defined
  shm_seq = new dtkSharedMem(sizeof(char)*100, "seqName");
  if(!shm_seq || shm_seq->isInvalid())
    shm_seq = NULL ;

  // have DSO compute according to the mode
  printf("mode: %s\n",argv[1]);
  if (strcasecmp("highlight",argv[1])==0) {
    strcpy(seqnode, argv[2]);

    // set the seqnodename
    if (shm_seq)
      shm_seq->write(seqnode);

    int mmode = 1;
    printf("mode to update highlight time\n");
    if (shm_mode)
      shm_mode->write(&mmode);
  }
  if (strcasecmp("calcBox",argv[1])==0) {
    int mmode = 2;
    printf("mode to recalculate box\n");

    // default is 2 plots = call makeSubPlots
    // otherwise there is another parameter
    if (argc > 2)
      numPlots = atoi(argv[2]);
    printf("numplots: %d\n",numPlots);

    if (shm_mode) {
      shm_mode->write(&mmode);

      // now wait for the DSO to reset mode back to 0
      while (mmode == 2) {
	shm_mode->read(&mmode);
      }

      // once the box is updated, call the program to remake the plot
      printf("calling makesubplots\n");
      if (numPlots == 2)
	system("makeSubPlots");
      if (numPlots ==4)
	system("make4SubPlots");
      printf("called makesubplots\n");

      // now have the DSO update the plot background
      mmode = 3;
      shm_mode->write(&mmode);
      printf("changed to mode 3\n");
      while (mmode == 3) {
	shm_mode->read(&mmode);
      }
      printf("DSO values are updated\n");
    }
  }
}

void usage() {
  printf("usage: hev-hydration-timeline highlight seqnode\n hev-hydration-timeline calcBox numPlots\n");
  exit(1);
}

bool isCommandCorrect(char* command) {
   bool isit = false;
   if (strcasecmp(command, "highlight") == 0) isit = true;
   if (strcasecmp(command, "calcBox") == 0) isit = true;
   return isit;
}
