#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <Performer/pf.h>
#include <Performer/pf/pfBillboard.h>

#include <Performer/pr.h>
#include <Performer/pr/pfTexture.h>
#include <Performer/pr/pfGeoState.h>
#include <Performer/pr/pfLinMath.h>
#include <Performer/pr/pfGeoSet.h>

#include <Performer/pfutil.h>
#include <Performer/pfdu.h>

#include <string>

using namespace std ;

// how many images in each direction- POSTS**3 images in all
int posts = 20 ;

extern "C" pfNode * pfdLoadFile_billboard (char *c_filename) {
  pfNotify(PFNFY_NOTICE, PFNFY_PRINT, "pfdLoadFile_billboard: %s", c_filename);

  string filename = c_filename ;
  filename = filename.erase(filename.rfind(".billboard")) ;
  printf("filename = \"%s\"\n",filename.c_str()) ;

  string sposts = filename ;
  sposts = filename.substr(filename.rfind('.')) ;
  printf("sposts = \"%s\"\n",sposts.c_str()) ;

  filename = filename.erase(filename.rfind(sposts)) ;
  printf("filename = \"%s\"\n",filename.c_str()) ;

  sposts = sposts.substr(1) ;
  printf("sposts = \"%s\"\n",sposts.c_str()) ;

  posts = atoi(sposts.c_str()) ;

  pfTexture   *tex;
  tex = new pfTexture ;

  if (!(tex->loadFile(filename.c_str()))) {
    pfNotify(PFNFY_FATAL, PFNFY_PRINT, 
	     "pfdLoadFile_billboard: couldn't load texture file %s",
	     filename.c_str());
    return(NULL) ;
  }

  int comp, ns, nt, nr;
  tex->getImage(NULL, &comp, &ns, &nt, &nr);
  
  printf("comp = %d\n",comp) ; // number of 8-bit components
  printf("ns   = %d\n",ns) ;   // number of pixels in x
  printf("nt   = %d\n",nt) ;   // number of pixels in y
  printf("nr   = %d\n",nr) ;   // number of pixels in z

  if (nr != 1) {
    pfNotify(PFNFY_FATAL, PFNFY_PRINT, 
    "pfdLoadFile_billboard: texture depth != 1");
    return(NULL) ;
  }

  pfGeoState *geostate;
  geostate = new pfGeoState ;

  if (comp > 3)
    geostate->setMode(PFSTATE_TRANSPARENCY, PFTR_HIGH_QUALITY);

  // set alpha function to block pixels of 0 alpha for 
  // transparent textures */
  geostate->setMode(PFSTATE_ALPHAFUNC, PFAF_NOTEQUAL);
  geostate->setVal(PFSTATE_ALPHAREF, 0.0f);
  geostate->setAttr(PFSTATE_TEXTURE, tex);
  //geostate->setAttr(PFSTATE_TEXMAT, mat);
  geostate->setMode(PFSTATE_ENTEXTURE, 1);
  //geostate->setMode(PFSTATE_ENTEXMAT, 1);
  //geostate->setMode(PFSTATE_ENLIGHTING, 0);
  geostate->setMode(PFSTATE_CULLFACE, PFCF_BACK);
  //geostate->setAttr(PFSTATE_TEXENV, tev);

  //coordinate information
  pfVec2 *texcoords = new pfVec2[4]; ;
  texcoords[0].set(0.0f, 0.0f) ;
  texcoords[1].set(1.0f, 0.0f) ;
  texcoords[2].set(1.0f, 1.0f) ;
  texcoords[3].set(0.0f, 1.0f) ;
  
  pfBillboard *bboard;
  bboard = new pfBillboard ;
  bboard->setMode(PFBB_ROT, PFBB_POINT_ROT_WORLD);
  bboard->setAxis(pfVec3(0.f, 0.f, 1.f)) ;
  int n = 0 ;
  int i, j, k ;
  float x, y, z ;
  float d = 2.f/((float)posts-1.f) ;
  float s = d/8.f ;

  for (i=0, x=-1.f; i<posts; i++, x+=d) {
    for (j=0, y=-1.f; j<posts; j++, y+=d) {
      for (k=0, z=-1; k<posts; n++, k++, z+=d) {

	pfGeoSet *geoset ;
	geoset = new pfGeoSet ;
	
	pfVec3 *coords = new pfVec3[4];
	coords[0].set(-(s),  0.f,  -(s)) ;
	coords[1].set( (s),  0.f,  -(s)) ;
	coords[2].set( (s),  0.f,   (s)) ;
	coords[3].set(-(s),  0.f,   (s)) ;
	
	geoset->setAttr(PFGS_COORD3, PFGS_PER_VERTEX, coords, NULL);
	geoset->setAttr(PFGS_TEXCOORD2, PFGS_PER_VERTEX, texcoords, NULL);
	geoset->setPrimType(PFGS_QUADS);
	geoset->setNumPrims(1);
	geoset->setGState(geostate);  

	bboard->addGSet(geoset) ;
	bboard->setPos(n, pfVec3(x,y,z)) ;
      }
    }
  }
  
  return(bboard) ;
}
