// reads a line from stdin- replaces \n with \0
// allocates space and sets input to its address

// returns the number of characters read, not including the \0

// the first time you call it, set input to NULL

// input can be reused- if not NULL its freed and a new string is returned

// to avoid memory leaks free(input) when all done

// the optional third parameter is a file pointer, defaults to stdin

#include <string.h>
#include <stdlib.h>
#define INIT_STRLEN (1024)

int getString(char **input, FILE *fp=stdin) {

  if (*input)
    free(*input) ;

  *input = (char *) malloc(INIT_STRLEN) ;
  if (!input) 
    fprintf(stderr,"\n\nMalloc returns NULL, %s, %d\n\n",__FILE__,__LINE__) ;
  int size = INIT_STRLEN ;


  int i = 0 ;
  int c ;
  while(1) {
    c = getc(fp) ;
    if (i==0 && c==EOF)
      return -1 ;
    else if (c=='\n' || c==EOF) {
      (*input)[i] = '\0' ;
      return i ;
    } else
      (*input)[i] = c ;
    i++ ;
    if (i==size) {
      size+=INIT_STRLEN ;
      *input = (char *) realloc(*input, size) ;
      if (!input) 
	fprintf(stderr,"\n\nRealloc returns NULL, %s, %d\n\n",__FILE__,__LINE__) ;
    }
  }
}


