/* 

   All this DSO does is to call pfMultiprocess(0), PFMP_APPCULLDRAW

   John Kelso, NIST, kelso@nist.gov, 1/05

*/

#include <dpf.h>
#include <dtk/dtkDSO_loader.h>

class singleProcess : public dtkAugment {
public:

  singleProcess(dpf *app) ;
  int preConfig(void);
} ;

singleProcess::singleProcess(dpf *app) :
  dtkAugment("singleProcess") {
  setDescription("calls pfMultiprocess(0)") ;
  validate();
} ;

int singleProcess::preConfig(void) {
  dtkMsg.add(DTKMSG_WARN,
	     "singleProcess: forcing application to run as a single process\n") ;
  pfMultiprocess(PFMP_APPCULLDRAW);
  return dtkAugment::REMOVE_CALLBACK ;
}

/*************** DTK C++ DSO loader/unloader functions ***********/
/*
 * All DTK DSO files are required to declare these two functions.
 * These function are called by the loading program to get your
 * C++ objects loaded.
 *
 *****************************************************************/

static dtkAugment *dtkDSO_loader(dtkManager *manager, void *p)
{
  dpf *app = static_cast<dpf *>(manager);
  return new singleProcess(app);
}

static int dtkDSO_unloader(dtkAugment *augment)
{
  delete augment;
  return DTKDSO_UNLOAD_CONTINUE;
}
