/*
 *       Scientific Applications & Visualization Group
 *            SAVG web page: http://math.nist.gov/mcsd/savg/
 *       Mathematical & Computational Science Division
 *            MCSD web page: http://math.nist.gov/mcsd/
 *       National Institute of Standards and Technology
 *            NIST web page: http://www.nist.gov/
 * 
 *  
 *  This software was developed at the National Institute of Standards
 *  and Technology by employees of the Federal Government in the course
 *  of their official duties. Pursuant to title 17 Section 105 of the
 *  United States Code this software is not subject to copyright
 *  protection and is in the public domain.  isolate is an experimental 
 *  system.  NIST assumes no responsibility whatsoever for its use by 
 *  other parties, and makes no guarantees, expressed or implied, about 
 *  its quality, reliability, or any other characteristic.
 *  
 *  We would appreciate acknowledgement if the software is used.
 * 
 */


/************************************************
 * savg-texture-square           		*
 * Created by: Adele Peskin		        *
 * Created on: 6-24-05				*
 * Current Version: 1.00			*
 *						*
 * Description:					*
 *    savg-texture-square creates a unit sized  *
 * 2d square with a texture mapped onto it from *
 * an image file.  One corner is located at the *
 * origin, while its opposite corner is located *
 * at (1, 1).                                   *                       *
 ************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "savgLineEvaluator.c"

/* Prints information on usage*/
void usage();

int main(argc, argv)
int argc;
char** argv;
{
/*
 * INITIALIZATION
 */
  char imageName[STRING_LENGTH];

/*
 * COMMAND LINE PROCESSING
 */

  // there should be exactly 1 parameter
  if (argc != 2) {
    usage();
    exit(EXIT_FAILURE);
  }

  strcpy(imageName,argv[1]);

/*
 * BODY
 */
  // first define a pfTexture
  printf("texture %s\n",imageName);

  // write out the geometry for the square, adding u,v coordinates
  printf("polygons 2DTEXTURE\n");
  printf("0 0 0 0 0 0 0 1\n");
  printf("1 0 0 1 0 0 0 1\n");
  printf("1 1 0 1 1 0 0 1\n");
  printf("0 1 0 0 1 0 0 1\n");
  
  return 0;
}

/* Prints information on usage*/
void usage()
{
	fprintf(stderr,
	"ERROR: Incorrect command line arguments\n"
	"\n"
	"USAGE:\n"
	"\tsavg-texture-square imageFileName\n");
}
